---
title: Element.getAttributeNames()
slug: Web/API/Element/getAttributeNames
tags:
  - API
  - Attribute
  - DOM
  - Element
  - Method
  - getAttributeNames
---
<div>{{APIRef("DOM")}}</div>

<p>The <strong><code>getAttributeNames()</code></strong> method of the {{domxref("Element")}} interface returns the attribute names of the element as an {{jsxref("Array")}} of strings. If the element has no attributes it returns an empty array.</p>

<p>Using <code>getAttributeNames()</code> along with {{domxref("Element.getAttribute","getAttribute()")}}, is a memory-efficient and performant alternative to accessing {{domxref("Element.attributes")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>let attributeNames</em> = element.getAttributeNames();
</pre>

<h2 id="Example">Example</h2>

<pre class="brush:js">// Iterate over element's attributes
for (let name of element.getAttributeNames()) {
  let value = element.getAttribute(name);
  console.log(name, value);
}
</pre>

<h2 id="Polyfill">Polyfill</h2>

<pre class="brush:js">if (Element.prototype.getAttributeNames == undefined) {
  Element.prototype.getAttributeNames = function () {
    var attributes = this.attributes;
    var length = attributes.length;
    var result = new Array(length);
    for (var i = 0; i &lt; length; i++) {
      result[i] = attributes[i].name;
    }
    return result;
  };
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("DOM WHATWG", "#dom-element-getattributenames", "Element.getAttributeNames")}}</td>
   <td>{{Spec2("DOM WHATWG")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Element.getAttributeNames")}}</p>
</div>
